; This is a minimum test-proggy..........
; Reading 1 sector from a CDROM
; Communicating with SCSI and ATAPI CD-ROM devices via ASPI
; by: Siekmanski.

; Works on Windows  95/98 SE and Windows ME
; For Windows 2000 Windows XP Windows Server 2003 we need an Aspidriver

; http://www.nero.com/nero6/eng/ASPI_Driver.html
; Or just download the latest NeroAspi Driver (for Windows NT/2000/XP):
; ftp://ftp6.nero.com/wnaspi32.dll

; You can find all info about "SCSI-3 Multimedia Commands (MMC)" at http://www.t10.org/drafts.htm

.486
.model FLAT,STDCALL
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include masm32.inc

include	wnaspi32.inc
include	scsidefs.inc

includelib user32.lib
includelib kernel32.lib
includelib masm32.lib

TEXT_ MACRO your_text:VARARG
	LOCAL text_string
	.data
	 text_string db your_text,0
	.code
	EXITM <addr text_string>
ENDM


.data

szHallo 				db "Siekmanski's ASPI CD-reader test 2006",13,10,13,10,0

szDrive_letter			db  "["
SCSI_Drive				db	" "
 						db	":/]",0

LBA_sector				dd 150	; sector to read

.data?

srbHAInquiry			SRB_HAInquiry <?>
srbGDEVBlock			SRB_GDEVBlock <?>
srbExecSCSICmd			SRB_ExecSCSICmd <?>
SCSI_buffer				db	256 dup (?)
SCSI_DataBuffer 		db	2352+96 dup (?) ; room for 1 sector

AspiLib					dd	?
SendASPI32Command_func	dd	?
GetASPI32Support_func	dd	?
SRBEvent				dd	?
HostAdapters_count		dd	?
CDrom_count				dd	?
CD_ROMS					dd	24 dup (?) ;Ha,Id,Lun,driveletter

SCSI_Ha					db	?
SCSI_Id					db	?
SCSI_Lun				db	?

szString_buffer			db	128 dup (?)


.code

;Zoek een Aspi-driver (WNASPI32.DLL) om te kunnen communiseren met de SCSI2/IDE/EIDE-bus.
;En haal het aantal Hostadapters en de adressen van de functie_routines die we nodig zijn.

AspiInit	proc
	mov		AspiLib,0
	mov		SRBEvent,0
	invoke	LoadLibrary,TEXT_("WNASPI32.DLL")
	mov		AspiLib,eax
	.if		(!eax)
		invoke	wsprintf,addr szString_buffer,TEXT_("WNASPI32.DLL not found...",13,10)
		jmp		Aspi_error
	.endif
	invoke	GetProcAddress,AspiLib,TEXT_("GetASPI32SupportInfo")
	mov		GetASPI32Support_func,eax
	.if		(!eax)
		invoke	wsprintf,addr szString_buffer,TEXT_("GetASPI32SupportInfo not found...",13,10)
		jmp		Aspi_error
	.endif
	invoke	GetProcAddress,AspiLib,TEXT_("SendASPI32Command")
	mov		SendASPI32Command_func,eax
	.if		(!eax)
		invoke	wsprintf,addr szString_buffer,TEXT_("SendASPI32Command not found...",13,10)
		jmp		Aspi_error
	.endif
	call	GetASPI32Support_func
	cmp		ah,SS_COMP	;status code byte (bit 8-15)
	jz		AspiSupport_Ok
	invoke	wsprintf,addr szString_buffer,TEXT_("No ASPI support...",13,10)
	jmp		Aspi_error
AspiSupport_Ok:
	and		eax,0fh		;aantal host adapters (bit 0-7)
	mov		HostAdapters_count,eax
	invoke	CreateEvent,NULL,TRUE,FALSE,NULL	; manual-reset event object, nonsignaled
	mov		SRBEvent,eax
	.if		(!eax)
		invoke	wsprintf,addr szString_buffer,TEXT_("ASPI CreateEvent failed...",13,10)
		jmp		Aspi_error
	.endif
	mov		eax,TRUE	; Ja.. Aspi ondersteuning
	ret

Aspi_error:
	invoke	StdOut,addr szString_buffer
	mov		eax,FALSE
	ret
AspiInit	endp

AspiRelease	proc
	.if	(SRBEvent != NULL)
		invoke	CloseHandle,SRBEvent
		mov		SRBEvent,NULL
	.endif
	.if	(AspiLib != NULL)
		invoke	FreeLibrary,AspiLib
		mov		AspiLib,NULL
	.endif
	ret
AspiRelease	endp

InitSRB_EXEC	proc
	push	edi
	lea		edi,srbExecSCSICmd
	xor		eax,eax
	mov		ecx,sizeof srbExecSCSICmd / 4
	cld
	rep		stosd
	lea		edi,SCSI_buffer
	xor		eax,eax
	mov		ecx,sizeof SCSI_buffer / 4
	cld
	rep		stosd
	mov		srbExecSCSICmd.SRB_Cmd,SC_EXEC_SCSI_CMD
	mov		al,SCSI_Ha
	mov		srbExecSCSICmd.SRB_HaId,al
	mov		al,SCSI_Id
	mov		srbExecSCSICmd.SRB_Target,al
	mov		al,SCSI_Lun
	mov		srbExecSCSICmd.SRB_Lun,al
	mov		srbExecSCSICmd.SRB_Flags,SRB_DIR_IN or SRB_EVENT_NOTIFY
	mov		srbExecSCSICmd.SRB_BufLen,sizeof SCSI_buffer
	mov		srbExecSCSICmd.SRB_BufPointer,offset SCSI_buffer
	mov		srbExecSCSICmd.SRB_SenseLen,SENSE_LEN
	mov		srbExecSCSICmd.SRB_CDBLen,12			; command descriptor block lengte --> MMC = 12
	mov		eax,SRBEvent
	mov		srbExecSCSICmd.SRB_PostProc,eax
	pop		edi
	ret
InitSRB_EXEC endp

SendASPI32Commando	proc scsi_struc:dword
	push	scsi_struc
	call	SendASPI32Command_func
	add		esp,4	; restore stack
	ret
SendASPI32Commando	endp


SendASPI32ExecCommando proc
LOCAL 	SCSICMDteller:dword 
	mov		SCSICMDteller,3
ExecSCSI:
	invoke	ResetEvent,SRBEvent
	push	offset srbExecSCSICmd
	call	SendASPI32Command_func
	add		esp,4	; restore stack
	cmp		srbExecSCSICmd.SRB_Status,SS_PENDING
	jnz		ExecSCSI_comp
	invoke	WaitForSingleObject,SRBEvent,INFINITE
	cmp		eax,WAIT_TIMEOUT
	jne		ExecSCSI_ok
	invoke	wsprintf,addr szString_buffer,TEXT_("ASPI-Event Timeout....",13,10)
	invoke	StdOut,addr szString_buffer
	jmp		ExecSCSI_fout
ExecSCSI_comp:
	cmp		srbExecSCSICmd.SRB_Status,SS_COMP
	jz		ExecSCSI_ok
	dec 	SCSICMDteller
	jnz 	ExecSCSI
ExecSCSI_fout:
	mov		eax,FALSE
	ret
ExecSCSI_ok:
	mov		eax,TRUE
	ret
SendASPI32ExecCommando endp


CDROM_Number proc nummer:dword
	push	edi
	push	ecx
	lea		edi,CD_ROMS
	mov		eax,nummer
	shl		eax,2
	mov		cl,[edi+eax]
	mov		SCSI_Ha,cl
	mov		cl,[edi+eax+1]
	mov		SCSI_Id,cl
	mov		cl,[edi+eax+2]
	mov		SCSI_Lun,cl
	mov		cl,[edi+eax+3]	
	mov		SCSI_Drive,cl
	pop		ecx
	pop		edi
	ret
CDROM_Number endp


; SCSI Bus Scan functie onderzoekt de SCSI2 bus op SCSI2 Hostadapters
; en de daarop aangesloten apparaten.
; Voor elk apparaat wordt de HOST, ID, LUN en TYPE gegeven.
; IDE/EIDE apparaten worden hierbij beschouwd als SCSI2 apparaten
; In deze routine zoek ik alleen naar CDROMS en DVDROMS (Atapi en/of SCSI2).

Find_cdroms proc
local szDrive:dword

	push	esi
	push	edi
	push	ebx
	xor		eax,eax
	mov		CDrom_count,eax
	mov		SCSI_Ha,al

Scan_Hostadapters:
	mov		SCSI_Id,0
	mov		SCSI_Lun,0
ScanSCSIAdapter:
	lea		edi,srbGDEVBlock
	xor		eax,eax
	mov		[edi],eax
	mov		[edi+4],eax
	mov		[edi+8],eax
	mov		srbGDEVBlock.SRB_Cmd,SC_GET_DEV_TYPE
	mov		al,SCSI_Ha
	mov		srbGDEVBlock.SRB_HaId,al
	mov		al,SCSI_Id
	mov		srbGDEVBlock.SRB_Target,al
	mov		al,SCSI_Lun
	mov		srbGDEVBlock.SRB_Lun,al
	invoke	SendASPI32Commando,addr srbGDEVBlock
	cmp		srbGDEVBlock.SRB_Status,SS_COMP
	jnz		Volgende_SCSILun
	cmp		srbGDEVBlock.SRB_DeviceType,DTYPE_CDROM	; controleer alleen op cdrom/dvdrom
	jne		Volgende_SCSILun		

	lea		edi,CD_ROMS
	mov		eax,CDrom_count
	shl		eax,2
	mov		cl,SCSI_Ha
	mov		[edi+eax],cl
	mov		cl,SCSI_Id
	mov		[edi+eax+1],cl
	mov		cl,SCSI_Lun
	mov		[edi+eax+2],cl	

	inc		CDrom_count
	cmp		CDrom_count,24	; maximaal 24 cdroms
	je		SCSIBusScan_einde

Volgende_SCSILun:
	inc		SCSI_Lun
	cmp		SCSI_Lun,MAXLUN		; Maximum Logical Unit Id
	jbe		ScanSCSIAdapter
	mov		SCSI_Lun,0
	inc		SCSI_Id
	cmp		SCSI_Id,MAXTARG		; Maximum Target Id
	jbe		ScanSCSIAdapter
Volgende_SCSIAdapter:
	inc		SCSI_Ha
	movzx	eax,SCSI_Ha
	cmp		eax,HostAdapters_count
	jb		Scan_Hostadapters
SCSIBusScan_einde:

	lea		edi,CD_ROMS
	lea		ebx,szDrive
	mov		dword ptr [ebx],05C3A43h   ; "C:\",0
	.while	byte ptr [ebx] <= "Z"
		invoke GetDriveType,ebx
		.if	eax == DRIVE_CDROM
			mov	eax,[ebx]
			mov	byte ptr [edi+3],al
			add	edi,4
      .endif
		inc byte ptr [ebx]
	.endw
	pop		ebx
	pop		edi
	pop		esi

	invoke	CDROM_Number,0

	ret
Find_cdroms endp


ReadSector proc Sector:dword
	invoke	InitSRB_EXEC
	mov		srbExecSCSICmd.SRB_BufLen,2352
	mov		srbExecSCSICmd.SRB_BufPointer,offset SCSI_DataBuffer
	lea		eax,srbExecSCSICmd.CDBByte	; command descriptor block
	mov		byte ptr [eax],0BEh		; read cd
	mov		byte ptr [eax+1],0 	; all types "cd-da mode 1 2 etc."  100b	= alleen audio data halen 
	mov		ecx,Sector
	bswap	ecx
	mov		dword ptr [eax+2],ecx 
	mov		byte ptr [eax+8],1		; 1 logical block
   	mov    	byte ptr [eax+9],11111000b	;read 2352 bytes
                            ;.......| reserved
                            ;.....||  no errors returned  
                            ;....|    edc-ecc
                            ;...|     user data
                            ;.||      all headers
                            ;|        sync
	mov		byte ptr [eax+10],0	; No sub-channel data

	invoke	SendASPI32ExecCommando
	ret
ReadSector endp


start:
	invoke	StdOut,addr szHallo

	invoke	AspiInit
	cmp		eax,FALSE
	je		sluit_prog

	invoke	Find_cdroms

	cmp		CDrom_count,0
	jnz		CDrom_gevonden
	invoke	wsprintf,addr szString_buffer,TEXT_("No CD-Roms found...",13,10)
	invoke	StdOut,addr szString_buffer
	jmp		sluit_prog
CDrom_gevonden:
	mov		eax,CDrom_count
	invoke	wsprintf,addr szString_buffer,TEXT_("CD-Roms found: %d",13,10,13,10),eax
	invoke	StdOut,addr szString_buffer

	invoke	CDROM_Number,0		;eerste cd-rom
	
	invoke	ReadSector,LBA_sector
   	.if (eax)
		invoke	StdOut,TEXT_("SendSCSIcommand OK !",13,10)
		lea	eax,SCSI_DataBuffer
		mov	eax,[eax]
		invoke	wsprintf,addr szString_buffer,TEXT_("First DWORD read from LBA_sector: %d = %xH",13,10,13,10),LBA_sector,eax
		invoke	StdOut,addr szString_buffer
	.else
		invoke	wsprintf,addr szString_buffer,TEXT_("CD-Rom not ready",13,10,13,10),LBA_sector,eax
		invoke	StdOut,addr szString_buffer		
	.endif

	invoke	AspiRelease

sluit_prog:

	invoke	Sleep,4000

	invoke	ExitProcess,0
end start